# -*- coding: utf8 -*-
from __future__ import unicode_literals

import datetime

parser_class = "au800"


def test_encode_order(self):
    expected = """
    H|\\^&||||||||||||20130715141912
    P|1||036666666||NYME^ANO||20110513^1^Y|F|||||ATTENDING||||||||||||LOC
    O|1|123456||^^^A^1|A||20130513114242||||N||||Serum|||1
    O|2|123456||^^^B^1|A||20130513114242||||A||||Serum|||1
    O|3|123456||^^^C^1|A||20130513114242||||C||||Serum|||1
    L|1|N
    """
    message = self.order()
    assert message == expected


def test_decode_result(self):
    worklist = self.decode(
        """
H|\\^&|||AutoMate^1||||||||NCCLS LIS2-A|20060622094704
M|1|103|1272249735^^|^|1|0|20060622094704||81|1||||1111^WSTN|
M|2|101|SAMPLE123|20060622094704|81
M|3|102|SAMPLE123^^0|1|1^410^1|75A\\02A\\03A\\63A\\73A|SAMPLE123^^^^
L|1|N
    """
    )
    expected = {
        "context": "result",
        "samples": [
            {
                "type": "patient",
                "sample_id": "1272249735",
                "rack": "WSTN Input/Output 1111--",
                "results": [
                    {
                        "code": "TRACKING",
                        "comments": ["Module Input/Output", "Rack 1111--"],
                        "date": datetime.datetime(2006, 6, 22, 9, 47, 4),
                        "instrument": "81",
                        "value": "WSTN",
                    }
                ],
            },
            {
                "type": "patient",
                "sample_id": "SAMPLE123",
                "results": [
                    {
                        "code": "TRACKING",
                        "date": datetime.datetime(2006, 6, 22, 9, 47, 4),
                        "instrument": "81",
                        "value": "101",
                        "date_plateau": datetime.datetime(2006, 6, 22, 9, 47, 4),
                    }
                ],
            },
        ],
    }
    assert worklist == expected
