# -*- coding: utf8 -*-
from __future__ import unicode_literals

parser_class = "colibri"


def test_decode_results(self):
    worklist = self.decode(
        """
    1012455,A1,180102,1,1
    1012455,A2,180102,1,1
    1012455,A3,,,2
    1012455,A4,180103,3,1
    1012455,A5,180103,3,1"""
    )
    expected = {
        "context": "result",
        "origin": "bruker",
        "samples": [
            {
                "bruker_positions": [
                    {
                        "code_barre": "180102",
                        "position": "A1",
                        "rang": 0,
                        "type_echantillon": 1,
                    },
                    {
                        "code_barre": "180102",
                        "position": "A2",
                        "rang": 0,
                        "type_echantillon": 1,
                    },
                    {"code_barre": "", "position": "A3", "type_echantillon": 2},
                    {
                        "code_barre": "180103",
                        "position": "A4",
                        "rang": 2,
                        "type_echantillon": 1,
                    },
                    {
                        "code_barre": "180103",
                        "position": "A5",
                        "rang": 2,
                        "type_echantillon": 1,
                    },
                ],
                "sample_id": "1012455",
                "type": "patient",
            }
        ],
    }

    assert worklist == expected
