# -*- coding: utf8 -*-
from __future__ import unicode_literals

parser_class = "genexpert_v46"


def test_encode_order(self):
    self.configure(
        genxpt_code_emetteur="1",
        genxpt_code_recepteur="LABOSUD LEPINE - 811526^GeneXpert^4.7b",
    )
    message = self.order()
    expected = """
    H|@^\\|20130715141912||1|||||LABOSUD LEPINE - 811526^GeneXpert^4.7b||P|1394-97|20130715141912
    P|1|||036666666|NYME^ANO||20110513|F
    O|1|123456||^^^A|R|20130603110342|||||A||||ORH||||||||||Q
    O|2|123456||^^^B|R|20130603110342|||||A||||ORH||||||||||Q
    O|3|123456||^^^C|R|20130603110342|||||C||||ORH||||||||||Q
    L|1|F
    """
    assert message == expected


def test_decode_query(self):
    worklist = self.decode(
        """
    H|\\^&|b4a88d9adab947a7b3dca2b534119c25||ICU^GeneXpert^1.0|||||LIS||P|1394-97|20140521100245
    Q|1|^123456||||||||||O
    L|1|N
    """
    )
    expected = {
        "context": "query",
        "samples": [{"type": "patient", "sample_id": "123456"}],
    }
    assert worklist == expected
